--- if_acx.c.orig	2004-07-01 15:40:09.000000000 +0300
+++ if_acx.c	2005-01-16 14:58:50.000000000 +0200
@@ -21,6 +21,7 @@
 #include "if_acxreg_proto.h"
 #include "if_acxdev_proto.h"
 #include "if_acxcmd_proto.h"
+#include "if_acxifnet.h"
 #include "if_acxifnet_proto.h"
 #include "if_acxtemplate_proto.h"
 #include "if_acxwep_proto.h"
@@ -80,8 +81,8 @@
     /* initialise: generic network interface */
     acx_ifnet_attach(sc);
     
-    ///* setup: wep default parameters */
-    //acx_wep_defaults(sc);
+    /* setup: wep default parameters */
+    /* acx_wep_defaults(sc); */
 
     /* display banner(s) */
     device_printf(sc->dev, "802.11 address: %s\n",
@@ -145,10 +146,10 @@
     struct acx_softc *sc= (struct acx_softc *)scarg;
     u_int16_t irqstatus;
 
-    mtx_lock(&sc->lock);
+    sc->lock = splimp();
     if(sc->irq_enabled == 0)
     {
-        mtx_unlock(&sc->lock);
+        splx(sc->lock);
         return; /* not our interrupt */
     }
 
@@ -157,24 +158,24 @@
 
     if(irqstatus == 0 )
     {
-        mtx_unlock(&sc->lock);
+        splx(sc->lock);
         return; /* not our interrupt */
     }
     
     if( irqstatus & ACX_DEV_INTF_RXX )  /* packet transferred to local host */
     {
-        taskqueue_enqueue_fast(taskqueue_fast, &sc->packet_task_rx);
+        taskqueue_enqueue(taskqueue_swi, &sc->packet_task_rx);
     }
     if( irqstatus & ACX_DEV_INTF_TX )   /* packet transferred to remote host */
     {
-        taskqueue_enqueue_fast(taskqueue_fast, &sc->packet_task_tx);
+        taskqueue_enqueue(taskqueue_swi, &sc->packet_task_tx);
     }
     if( irqstatus & ACX_DEV_INTF_CMD )
     {
-        taskqueue_enqueue_fast(taskqueue_fast, &sc->cmd_task_irq);
+        taskqueue_enqueue(taskqueue_swi, &sc->cmd_task_irq);
     }
 
-    mtx_unlock(&sc->lock);
+    splx(sc->lock);
 
     return;
 }
