--- if_acxcmd.c.orig	2004-07-01 15:20:41.000000000 +0300
+++ if_acxcmd.c	2005-01-16 14:58:50.000000000 +0200
@@ -9,7 +9,7 @@
  */
 
 #define ACX_CMD_DEBUG
-//#define ACX_CMD_DEBUG_ENTER
+/* #define ACX_CMD_DEBUG_ENTER */
 
 /****************************************************************************************************************
  * functions to interact with the firmware via the FW register set in order to issue firmware commands          *
@@ -126,15 +126,11 @@
         /* priority */ 0,
         /* function */ (task_fn_t *)acx_cmd_task_irq,
         /* context  */ sc);
-
-    /* initialise command lock */
-    mtx_init(&sc->cmd_lock, device_get_nameunit(sc->dev), "cmd lock", MTX_DEF);
 }
 
 void
 acx_cmd_end(struct acx_softc *sc)
 {
-    mtx_destroy(&sc->cmd_lock);
 }
 
 /*
@@ -312,7 +308,7 @@
 {
     struct acx_cmd_entry *cmd;
 
-    mtx_lock(&sc->cmd_lock);
+    sc->cmd_lock = splimp();
     
     /* determine pending command */
     if( (cmd= STAILQ_FIRST(&sc->cmd_head)) == NULL )
@@ -321,7 +317,7 @@
     /* start the command */
     acx_cmd_start(sc, cmd);
     
-    mtx_unlock(&sc->cmd_lock);
+    splx(sc->cmd_lock);
 }
 
 /*
@@ -368,7 +364,7 @@
 {
     struct acx_cmd_entry *cmd, *top;
     
-    mtx_lock(&sc->cmd_lock);
+    sc->cmd_lock = splimp();
     
     /* determine current command */
     cmd= sc->cmd;
@@ -382,7 +378,7 @@
     /* determing if another command is pending */
     top= STAILQ_FIRST(&sc->cmd_head);
 
-    mtx_unlock(&sc->cmd_lock);
+    splx(sc->cmd_lock);
     
     /* wakeup blocking thread or call callback for non blocking */
     if( cmd->callback_func==ACX_CMD_BLOCK )
@@ -405,7 +401,7 @@
     struct acx_cmd_entry *top;
     int error;
 
-    mtx_lock(&sc->cmd_lock);
+    sc->cmd_lock = splimp();
 
     if( sc->irq_enabled )   /* irqs available */
     {
@@ -425,7 +421,7 @@
              * 2) sleep
              * 3) reacquire lock
              */
-            if( (error= msleep(cmd, &sc->cmd_lock, 0, "msleep", ACX_CMD_BLOCK_TIMEOUT)) != 0)
+            if( (error= tsleep(cmd, 0, "tsleep", ACX_CMD_BLOCK_TIMEOUT)) != 0)
             {
 #ifdef ACX_CMD_DEBUG
                 device_printf(sc->dev, "command timeout (QUEUED)\n");
@@ -468,7 +464,7 @@
     }
     else panic("acx%d: non blocking command disallowed in this context\n", sc->unit);
 
-    mtx_unlock(&sc->cmd_lock);
+    splx(sc->cmd_lock);
 }
 
 /*********************
