--- if_acxifnet.c.orig	2004-07-01 15:20:42.000000000 +0300
+++ if_acxifnet.c	2005-01-16 14:58:50.000000000 +0200
@@ -57,11 +57,8 @@
     ic = &sc->ic;
     ifp = &ic->ic_if;
 
-    /* lock */
-    mtx_init(&sc->ifnet_lock, device_get_nameunit(sc->dev), "ifnet lock", MTX_DEF);
-
     /* initialise scan callout without a lock */
-    callout_init(&sc->ifnet_callout_scan, 0 /*CALLOUT_MPSAFE*/);
+    callout_init(&sc->ifnet_callout_scan);
 
     /* setup generic interface */
     if_initname(ifp, device_get_name(sc->dev), device_get_unit(sc->dev));
@@ -104,8 +101,8 @@
 
     ic->ic_caps   = IEEE80211_C_WEP |           /* wep supported */
                     IEEE80211_C_IBSS |          /* ibss/adhoc modes */
-                    //IEEE80211_C_HOSTAP |      /* hostap mode */
-                    //IEEE80211_C_MONITOR |     /* monitor mode */
+                    /* IEEE80211_C_HOSTAP | */  /* hostap mode */
+                    /* IEEE80211_C_MONITOR | */ /* monitor mode */
                     IEEE80211_C_SHPREAMBLE      /* short preamble supported */
                     /*IEEE80211_C_RCVMGT*/ ;    /* recv management frames */
 
@@ -147,14 +144,14 @@
 struct ieee80211_node *
 acx_ifnet_node_alloc(struct ieee80211com *ic)
 {
-//    struct ifnet *ifp= &ic->ic_if;
-//    struct acx_softc *sc= ifp->if_softc;
+/*    struct ifnet *ifp= &ic->ic_if; */
+/*    struct acx_softc *sc= ifp->if_softc; */
 
     struct acx_ifnet_node *ni;
 
     MALLOC(ni, struct acx_ifnet_node *, sizeof(struct acx_ifnet_node), ACX_NODE, M_NOWAIT | M_ZERO);
 
-//    device_printf(sc->dev, "acx_ifnet_node_alloc: %p\n", ni);
+/*    device_printf(sc->dev, "acx_ifnet_node_alloc: %p\n", ni); */
 
     return (struct ieee80211_node *)ni;
 }
@@ -182,8 +179,6 @@
     
     ifp = &sc->ic.ic_if;
     ieee80211_ifdetach(ifp);
-
-    mtx_destroy(&sc->ifnet_lock);
 }
 
 /*
@@ -242,12 +237,12 @@
  * handle device ioctl
  */  
 int
-acx_ifnet_ioctl(struct ifnet *ifp, u_long cmd, caddr_t data)
+acx_ifnet_ioctl(struct ifnet *ifp, u_long cmd, caddr_t data, struct ucred *cr)
 {
     struct acx_softc *sc = ifp->if_softc;
     int error = 0;
     struct ieee80211req *ieee80211req;
-    //struct ieee80211com *ic= &sc->ic;
+    /* struct ieee80211com *ic= &sc->ic; */
 
     switch (cmd)
     {
@@ -267,10 +262,9 @@
             break;
 
         default:
-            //
-            //acx_cmd_set_ssid(struct acx_softc *sc, char *nwid, int nwidlen)
+            /* acx_cmd_set_ssid(struct acx_softc *sc, char *nwid, int nwidlen) */
             
-            error = ieee80211_ioctl(ifp, cmd, data);
+            error = ieee80211_ioctl(ifp, cmd, data, cr);
 
             if( cmd==SIOCS80211 )                       /* pass wep update to the firmware */
             {
@@ -307,7 +301,7 @@
                 }
             }
 
-            if( error==ENETRESET) // XXX do not reset on fixed rate change, else association wedges
+            if( error==ENETRESET) /* XXX do not reset on fixed rate change, else association wedges */
             {
                 if( ifp->if_flags & IFF_RUNNING )
                     acx_ifnet_down(ifp);
@@ -395,8 +389,8 @@
     struct ieee80211com *ic = &sc->ic;
 
     /* turn on promiscuous mode */
-    //if( ifp->if_flags & IFF_PROMISC )
-    //rx_config &= ~ACX_CMD_RXCFG_UNPROMISCUOUS;
+    /* if( ifp->if_flags & IFF_PROMISC ) */
+    /* rx_config &= ~ACX_CMD_RXCFG_UNPROMISCUOUS; */
 
     /* set receiver config (want beacons) */
     acx_cmd_set_rx_config_nb(sc, ACX_CMD_RXCFG_BEACON);
@@ -485,3 +479,24 @@
     }
     return(*sc->ic_newstate)(ic, newstate, arg);
 }
+
+/*
+ * print ethernet address 
+ */
+
+char *
+ether_sprintf(u_char *ap)
+{
+	char digs[] = "0123456789abcdef";
+	int i;
+	static char ebuf[18];
+	char *cp = ebuf;
+
+	for (i = 0; i < 6; i++) {
+		*cp++ = digs[*ap >> 4];
+		*cp++ = digs[*ap++ & 0xf];
+		*cp++ = ':';
+	}
+	*--cp = 0;
+	return (ebuf);
+}
