--- if_acxpacket.c.orig	2004-07-01 15:20:43.000000000 +0300
+++ if_acxpacket.c	2005-01-16 14:58:50.000000000 +0200
@@ -39,10 +39,6 @@
 int
 acx_packet_attach(struct acx_softc *sc)
 {
-    /* initialise locks */
-    mtx_init(&sc->rx_lock, device_get_nameunit(sc->dev), "packet rx lock", MTX_DEF);
-    mtx_init(&sc->tx_lock, device_get_nameunit(sc->dev), "packet tx lock", MTX_DEF);
-    
     /*
      * create dma tag for tx/rx descriptors
      *
@@ -71,8 +67,6 @@
         /* nsegments */     1,                                          /* number of segments in the map */
         /* maxsegsz */      ACX_PACKET_DESCSIZE * ACX_PACKET_RINGSIZE,  /* size of the segment in the map */
         /* flags */         0,
-        /* lockfunc */      NULL,
-        /* lockfuncarg */   NULL,
         /* dmat */          &sc->dma_desctag) != 0)
     {
         device_printf(sc->dev, "failed to create dma tag\n");
@@ -94,8 +88,6 @@
         /* nsegments */     1,                                          /* number of segments in the map */
         /* maxsegsz */      MCLBYTES,                                   /* size of the segment in the map */
         /* flags */         0,
-        /* lockfunc */      NULL,
-        /* lockfuncarg */   NULL,
         /* dmat */          &sc->dma_bufftag) != 0)
     {
         device_printf(sc->dev, "failed to create dma tag\n");
@@ -250,9 +242,6 @@
 
     bus_dma_tag_destroy(sc->dma_bufftag);
     bus_dma_tag_destroy(sc->dma_desctag);
-
-    mtx_destroy(&sc->tx_lock);
-    mtx_destroy(&sc->rx_lock);
 }
 
 int
@@ -463,7 +452,7 @@
     bufmap->type= ACX_PACKET_TYPE_MBUF;
 
     /* allocate mbuf with extermal data storage area. see kern/subr_mbuf.c */
-    bufmap->buf.m= m_getcl(M_DONTWAIT, MT_DATA, M_PKTHDR);
+    bufmap->buf.m= m_getcl(MB_DONTWAIT, MT_DATA, M_PKTHDR);
     if(bufmap->buf.m == NULL)
         return ENOBUFS;
 
@@ -710,7 +699,7 @@
     u_int8_t rxtest, *payload;
     int len, payloadlen;
 
-    mtx_lock(&sc->rx_lock);
+    sc->rx_lock = splimp();
 
     /* sync desriptor table */
     bus_dmamap_sync(sc->dma_desctag, sc->dma_map_rxdesc, BUS_DMASYNC_POSTREAD|BUS_DMASYNC_POSTWRITE);
@@ -763,7 +752,7 @@
                     rxdesc->fc0= frame->i_fc[0];
                     rxdesc->fc1= frame->i_fc[1];
 
-                    //ieee80211_dump_pkt((u_int8_t *)frame, len, 0, tiheader->level);
+                    /* ieee80211_dump_pkt((u_int8_t *)frame, len, 0, tiheader->level); */
                         
                     /* reference node and save for debugging */
                     if(ic->ic_opmode == IEEE80211_M_STA)
@@ -860,7 +849,7 @@
      */
     bus_space_write_2( sc->mem1.bustag, sc->mem1.bushandle, sc->regmap[ACX_REG_IRQ_ACK], ACX_DEV_INTF_RXX);
 
-    mtx_unlock(&sc->rx_lock);
+    splx(sc->rx_lock);
 }
 
 /*
@@ -882,7 +871,7 @@
     bus_size_t offset;
     int x, y;
 
-    mtx_lock(&sc->tx_lock);
+    sc->tx_lock = splimp();
 
     while( (&ic->ic_mgtq)->ifq_head!=NULL || (&ifp->if_snd)->ifq_head!=NULL )
     {
@@ -895,7 +884,7 @@
         if( (control & ACX_PACKET_CTL_FREE) == 0 || (control & ACX_PACKET_CTL_INUSE)  )
         {
             ifp->if_flags|= IFF_OACTIVE;
-            mtx_unlock(&sc->tx_lock);
+            splx(sc->tx_lock);
             return; /* tx queue full */
         }
 
@@ -906,7 +895,7 @@
             if( mbuf == NULL )
             {
                 device_printf(sc->dev, "acx_packet_tx: IF_DEQUEUE (mgmt) ret NULL mbuf\n");
-                mtx_unlock(&sc->tx_lock);
+                splx(sc->tx_lock);
                 return;
             }
 
@@ -936,7 +925,7 @@
         {
             if(ic->ic_state!=IEEE80211_S_RUN || !(ifp->if_flags & IFF_UP))
             {
-                mtx_unlock(&sc->tx_lock);
+                splx(sc->tx_lock);
                 return;
             }
 
@@ -944,7 +933,7 @@
             if( mbuf == NULL )
             {
                 device_printf(sc->dev, "acx_packet_tx: IF_DEQUEUE (data) ret NULL mbuf\n");
-                mtx_unlock(&sc->tx_lock);
+                splx(sc->tx_lock);
                 return;
             }
 
@@ -956,7 +945,7 @@
             if( mbuf == NULL )
             {
                 device_printf(sc->dev, "acx_packet_tx: ieee80211_encap ret NULL mbuf\n");
-                mtx_unlock(&sc->tx_lock);
+                splx(sc->tx_lock);
                 return;
             }
 
@@ -1013,26 +1002,28 @@
         {
             device_printf(sc->dev, "acx_packet_tx: problem: dropping short packet: m_pkthdr.len %d\n", mbuf->m_pkthdr.len);
             m_freem(mbuf);
-            mtx_unlock(&sc->tx_lock);
+            splx(sc->tx_lock);
             return;
         }
         if( mbuf->m_pkthdr.len > MCLBYTES)
         {
             device_printf(sc->dev, "acx_packet_tx: problem: dropping long packet: m_pkthdr.len %d\n", mbuf->m_pkthdr.len);
             m_freem(mbuf);
-            mtx_unlock(&sc->tx_lock);
+            splx(sc->tx_lock);
             return;
         }
 
         /* feed sniffer */
+#ifdef IEEE80211_RAWBPF
         if (ic->ic_rawbpf)
             bpf_mtap(ic->ic_rawbpf, mbuf);
+#endif
 
         /* copy mbuf cluster into buffer */
         txbuf= &sc->txbuf[sc->tx_ring];
         m_copydata(mbuf, 0, mbuf->m_pkthdr.len, txbuf->buf.b);
 
-        packet_len= mbuf->m_pkthdr.len; // + IEEE80211_CRC_LEN;
+        packet_len= mbuf->m_pkthdr.len; /* + IEEE80211_CRC_LEN; */
         m_freem(mbuf);
         bus_dmamap_sync(sc->dma_bufftag, txbuf->map, BUS_DMASYNC_PREREAD);
 
@@ -1078,7 +1069,7 @@
         ifp->if_timer= 5;
     }
 
-    mtx_unlock(&sc->tx_lock);
+    splx(sc->tx_lock);
 }
 
 /*
@@ -1229,7 +1220,7 @@
     u_int8_t ix, control, error;
 
     /* LOCK */
-    mtx_lock(&sc->tx_lock);
+    sc->tx_lock = splimp();
 
     /* next descriptor for TX (we will test this last) */
     ix = sc->tx_ring;
@@ -1304,7 +1295,7 @@
     bus_space_write_2( sc->mem1.bustag, sc->mem1.bushandle, sc->regmap[ACX_REG_IRQ_ACK], ACX_DEV_INTF_TX);
 
     /* UNLOCK */
-    mtx_unlock(&sc->tx_lock);
+    splx(sc->tx_lock);
 
     /* continue processing TX queue */
     acx_packet_tx(ifp);
